;COLORBEPPP by utz/irrlicht project 05'2013
;uses ZX7 (de)compression by Einar Saukas
;graphics inspired by g0blinish's colortrash32b (and Hikaru's remix thereof),
; though no code has been used from that.
;Everything else done by myself.
;The code isn't optimized at all, probably the whole thing would fit into 512 bytes.
;But I have the flu right now so my head is mushy and I can't be arsed to do it.



            ORG #8000
begin
		xor a             		; set border color.
		call 8859           	
			
		ld a,6              	
		ld (23693),a        	; set our screen colours.
		call 3503           	; clear the screen.
	
		ld a,22             	; AT code.
		rst 16
		ld a,6
		ld (65023),a
		rst 16              	; set vertical position of player.
		ld a,13			    	; set horizontal
		rst 16

		ld a,2              	; upper screen
		call 5633           	; open channel
		ld de,msg1	        	; address of string
		ld bc,emsg1-msg1  		; length of string to print
		call 8252           	; print our string
	
		ld a,22
		rst 16
		ld a,9
		ld (65023),a
		rst 16
		ld a,4
		rst 16	

		ld de,msg2
		ld bc,emsg2-msg2
		call 8252

		di
		ld hl,dlpx1
		ld (dcp),hl
		ld bc,#01ff
		ld hl,3000
wlp:
		push hl
		push bc
		call drum1
		pop bc
		pop hl
		ld a,$ff
wlp1:	
		push ix
		pop ix
		dec a
		jr nz,wlp1
		dec bc
		ld a,b
		or c
		jr nz,wlp

		ld hl,dlpx
		ld (dcp),hl
		xor a
		ld (23693),a
		call 3503           	; clear the screen.
	
		ld hl,screen
		ld de,16384
		call dzx7
		
		ld hl,sngdt
		ld de,spd
		call dzx7

rinit	call init
		jr rinit

init:
		ld hl,spd
rdata:
		ld b,#12		;read speed
		ld c,b
		inc hl			;read song data
		ld a,(hl)
		or a
		jr z,nodrum
		cp #ff
		ret z	
		push hl
		ld hl,#3000
		push bc
		dec a
		call z,drum1
		dec a
		call z,drum2
		pop bc
		dec b
		pop hl
nodrum:	inc hl
		ld d,(hl)
		inc hl
		ld e,(hl)
		push de
		exx
		ld hl,#5806
		exx
	
sndlp:	exx
		inc a
		ld e,a
		ex af,af'
		ld d,h
		add a,l
		ld (de),a
		inc d
		ld (de),a
		inc d
		ld (de),a
		ex af,af'
		exx

		xor a			;clear outval
	
		dec d
		jr nz,skip1
		ld a,e
		pop de
		push de
		ld e,a
		ld a,#13
	
skip1:	dec e
		jr nz,skip2
		ld a,d
		pop de
		push de
		ld d,a
		ld a,#11	

skip2:	out (#fe),a

		dec bc
		ld a,b
		or c
		jr nz,sndlp
		pop de
		jr rdata


drum2:	ld bc,$03fd
dlp2:	call dlpx
		ld a,b
		or c
		jr nz,dlp2
		ret

drum1:	ld de,$0809
		ld b,72
dcp EQU $+1	
dlp3:	call dlpx
dlp4:	dec d
		jr nz,dlp4
		ld d,e
		inc e
		djnz dlp3
		ret

dlpx:	ld a,(hl)
		or %11100000
		xor %11100000
		out (#fe),a
		inc hl
		dec bc
		ret

dlpx1:	ld a,(hl)
		or %11110000
		xor %11110000
		out (#fe),a
		inc hl
		dec bc
		ret	
	
	
dzx7:
		ld a,#80
copy_byte_loop:
        ldi                             ; copy literal byte
main_loop:
        call    next_bit
        jr      nc, copy_byte_loop      ; next bit indicates either literal or sequence

; determine number of bits used for length (Elias gamma coding)
        push    de
        ld      bc, 0
        ld      d, b
length_size_loop:
        inc     d
        call    next_bit
        jr      nc, length_size_loop

; determine length
length_value_loop:
        call    nc, next_bit
        rl      c
        rl      b
        jr      c, exit                 ; check end marker
        dec     d
        jr      nz, length_value_loop
        inc     bc                      ; adjust length

; determine offset
        ld      e, (hl)                 ; load offset flag (1 bit) + offset value (7 bits)
        inc     hl
        defb    $cb, $33                ; opcode for undocumented instruction "SLS E"
        jr      nc, offset_end          ; if offset flag is set, load 4 extra bits
        call    next_bit
        call    rld_next_bit            ; insert first bit into D
        call    rld_next_bit            ; insert second bit into D
        call    rld_next_bit            ; insert third bit into D
offset_end:
        rr      e                       ; insert fourth bit into E

; copy previous sequence
        ex      (sp), hl                ; store source, restore destination
        push    hl                      ; store destination
        sbc     hl, de                  ; HL = destination - offset - 1
        pop     de                      ; DE = destination
        ldir
        pop     hl                      ; restore source address (compressed data)
        jr      main_loop

rld_next_bit:
        rl      d                       ; insert previous bit into D
next_bit:
        add     a, a                    ; check next bit
        ret     nz                      ; no more bits left?
        ld      a, (hl)                 ; load another group of 8 bits
        inc     hl
        rla
        ret

exit:
        pop     de
        ret	

screen:	
	INCBIN 'colbep.scr.zx7'
	
sngdt:
	INCBIN 'sdata.bin.zx7'

msg1:
	db 'WARNING'
emsg1:	

msg2:
	db 'The demo you are about to        watch is extremely bad.     If you are easily offended by  lame graphic effects and crappy  music, turn off your Spectrum                now.'
emsg2:
    
spd:	nop
end

